// Generated by CoffeeScript 1.12.5
var Dirator, Path, corepath, fn, fs, i, len, ref, type,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

fs = require('fs');

corepath = require('path');

Path = require('fspath');

Dirator = (function(superClass) {
  extend(Dirator, superClass);

  function Dirator(options, done) {
    this._configure(options, done);
  }

  Dirator.prototype._configure = function(options, done) {
    var accept, event, i, j, k, len, len1, len2, ref, ref1, ref2, ref3, ref4, ref5;
    if (options == null) {
      options = {};
    }
    this.only = [];
    this.target = (ref = options.target) != null ? ref : process.cwd();
    if (done == null) {
      done = (ref1 = options.done) != null ? ref1 : ('function' === typeof options ? options : void 0);
    }
    if (done != null) {
      this.on('done', done);
      this.async = true;
    }
    ref2 = ['file', 'dir', 'path'];
    for (i = 0, len = ref2.length; i < len; i++) {
      event = ref2[i];
      if (options[event] != null) {
        this.on(event, options[event]);
        this.only[this.only.length] = event + 's';
      }
    }
    ref3 = ['files', 'dirs', 'paths'];
    for (j = 0, len1 = ref3.length; j < len1; j++) {
      event = ref3[j];
      if (options[event] != null) {
        this.on(event, options[event]);
        if (indexOf.call(this.only, event) < 0) {
          this.only[this.only.length] = event;
        }
      }
    }
    ref4 = ['acceptString', 'acceptPath'];
    for (k = 0, len2 = ref4.length; k < len2; k++) {
      accept = ref4[k];
      this['_' + accept] = options[accept];
    }
    this.recurse = options.recurse !== false;
    if (options.only != null) {
      this.only = options.only;
    }
    if (!((ref5 = this.only) != null ? ref5.length : void 0)) {
      return this.only = ['paths'];
    }
  };

  Dirator.prototype.on = function(event, listener) {
    switch (event) {
      case 'done':
        this.async = true;
        break;
      case 'file':
      case 'files':
        this.only[this.only.length] = 'files';
        break;
      case 'dir':
      case 'dirs':
        this.only[this.only.length] = 'dirs';
        break;
      case 'path':
      case 'paths':
        this.only[this.only.length] = 'paths';
    }
    return Dirator.__super__.on.call(this, event, listener);
  };

  Dirator.prototype.run = function(options, done) {
    if ((options != null) || (done != null)) {
      this._configure(options, done);
    }
    if (this.target == null) {
      throw new Error('dirator requires a `target` to run');
    }
    if (this.async) {
      return this._iterate([new Path(this.target)]);
    } else {
      return this._iterateSync();
    }
  };

  Dirator.prototype._iterateSync = function() {
    var dir, dirArray, emit, i, j, len, len1, options, path, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, ref8, ref9, result, results, type;
    results = {
      found: {},
      rejected: {
        paths: 0,
        strings: 0
      }
    };
    emit = {};
    ref = ['files', 'dirs', 'paths'];
    for (i = 0, len = ref.length; i < len; i++) {
      type = ref[i];
      if (indexOf.call(this.only, type) >= 0) {
        results[type] = [];
        results.found[type] = 0;
      }
    }
    dirArray = [new Path(this.target)];
    options = {
      acceptString: this._acceptString,
      acceptPath: this._acceptPath
    };
    while (dirArray.length > 0) {
      dir = dirArray.pop();
      result = dir.list(options);
      results.rejected.paths += result.rejected.paths;
      results.rejected.strings += result.rejected.strings;
      if (((ref1 = results.found) != null ? ref1.paths : void 0) != null) {
        results.found.paths += result.paths.length;
      }
      ref2 = result.paths;
      for (j = 0, len1 = ref2.length; j < len1; j++) {
        path = ref2[j];
        if (results != null) {
          if ((ref3 = results.paths) != null) {
            ref3.push(path);
          }
        }
        if (path.isDir()) {
          if (((ref4 = results.found) != null ? ref4.dirs : void 0) != null) {
            if ((ref5 = results.found) != null) {
              ref5.dirs += 1;
            }
          }
          if (this.recurse) {
            dirArray[dirArray.length] = path;
          }
          if (results != null) {
            if ((ref6 = results.dirs) != null) {
              ref6.push(path);
            }
          }
        } else if (path.isFile()) {
          if (((ref7 = results.found) != null ? ref7.files : void 0) != null) {
            if ((ref8 = results.found) != null) {
              ref8.files += 1;
            }
          }
          if (results != null) {
            if ((ref9 = results.files) != null) {
              ref9.push(path);
            }
          }
        }
      }
    }
    return results;
  };

  Dirator.prototype._iterate = function(dirArray, options) {
    var dir;
    if (options == null) {
      options = this._buildAsyncOptions(dirArray);
      dirArray.options = options;
    }
    if (dirArray.length > 0) {
      dir = dirArray.pop();
      return dir.list(options.list);
    } else {
      return this.emit('done', void 0, options.results);
    }
  };

  Dirator.prototype._buildAsyncOptions = function(dirArray) {
    var action, list, results;
    action = {};
    results = {
      found: {},
      rejected: {
        paths: 0,
        strings: 0
      }
    };
    list = {
      acceptString: this._acceptString,
      acceptPath: this._acceptPath,
      each: function(result) {
        if (typeof action.file === "function") {
          action.file(result);
        }
        if (typeof action.dir === "function") {
          action.dir(result);
        }
        return typeof action.path === "function" ? action.path(result) : void 0;
      },
      done: (function(_this) {
        return function(error, result) {
          if (error != null) {
            return _this.emit('done', error, result);
          }
          if (typeof action.files === "function") {
            action.files(result);
          }
          if (typeof action.dirs === "function") {
            action.dirs(result);
          }
          if (typeof action.paths === "function") {
            action.paths(result);
          }
          results.rejected.paths += result.rejected.paths;
          results.rejected.strings += result.rejected.strings;
          if (_this.recurse) {
            return _this._iterate(dirArray, dirArray.options);
          } else {
            return _this.emit('done', void 0, results);
          }
        };
      })(this)
    };
    if (indexOf.call(this.only, 'files') >= 0) {
      action.tempFiles = [];
      results.found.files = 0;
      action.file = (function(_this) {
        return function(result) {
          var path;
          path = result.path;
          if (path.isFile()) {
            action.tempFiles[action.tempFiles.length] = path;
            return _this.emit('file', path);
          }
        };
      })(this);
      action.files = (function(_this) {
        return function() {
          results.found.files += action.tempFiles.length;
          _this.emit('files', action.tempFiles);
          return action.tempFiles = [];
        };
      })(this);
    }
    if (indexOf.call(this.only, 'dirs') >= 0) {
      action.tempDirs = [];
      results.found.dirs = 0;
      action.dir = (function(_this) {
        return function(result) {
          var path;
          path = result.path;
          if (path.isDir()) {
            if (_this.recurse) {
              dirArray[dirArray.length] = path;
            }
            action.tempDirs[action.tempDirs.length] = path;
            result.dir = path;
            return _this.emit('dir', path);
          }
        };
      })(this);
      action.dirs = (function(_this) {
        return function() {
          results.found.dirs += action.tempDirs.length;
          _this.emit('dirs', action.tempDirs);
          return action.tempDirs = [];
        };
      })(this);
    } else if (this.recurse) {
      action.dir = function(result) {
        if (result.path.isDir()) {
          return dirArray[dirArray.length] = result.path;
        }
      };
    }
    if (indexOf.call(this.only, 'paths') >= 0) {
      results.found.paths = 0;
      action.path = (function(_this) {
        return function(result) {
          return _this.emit('path', result.path);
        };
      })(this);
      action.paths = (function(_this) {
        return function(result) {
          results.found.paths += result.paths.length;
          return _this.emit('paths', result.paths);
        };
      })(this);
    }
    return {
      action: action,
      results: results,
      list: list
    };
  };

  return Dirator;

})(require('events').EventEmitter);

module.exports = function(options, done) {
  return new Dirator(options, done).run();
};

module.exports.Dirator = Dirator;

ref = ['files', 'dirs', 'paths'];
fn = function(type) {
  return module.exports[type] = function(options, done) {
    if (options == null) {
      options = {};
    }
    options.only = [type];
    if (done != null) {
      options.done = done;
    }
    return new Dirator(options).run();
  };
};
for (i = 0, len = ref.length; i < len; i++) {
  type = ref[i];
  fn(type);
}
